/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.particle.elements;

import de.steamwar.lobby.particle.ParticleElement;
import de.steamwar.lobby.particle.ParticleTickData;
import de.steamwar.lobby.particle.ParticleTickType;
import org.bukkit.Location;
import org.bukkit.util.Vector;

public class DoubleCircle extends Circle {

    private ParticleElement second;

    private double distance;
    private double speed;

    public DoubleCircle(ParticleElement first, ParticleElement second) {
        super(first);
        this.second = second;
        this.distance = 1;
        this.speed = 1;
    }

    public DoubleCircle(ParticleElement first, ParticleElement second, double distance, double speed) {
        super(first);
        this.second = second;
        this.distance = distance;
        this.speed = speed;
    }

    @Override
    public String attribute() {
        return "PARTICLE_ATTRIBUTE_BI_CIRCLE";
    }

    @Override
    public ParticleTickType tickType() {
        if (particleElement.tickType() == second.tickType()) {
            return particleElement.tickType();
        }
        return ParticleTickType.MOVE;
    }

    @Override
    public void tick(ParticleTickData particleTickData) {
        Location location = particleTickData.getLocation();

        Vector vector = new Vector(distance, 0, 0);
        vector.rotateAroundY((particleTickData.getDeg() * speed) % 360);
        ParticleTickData nParticleTickData = particleTickData.withLocation(location.clone().add(vector));
        particleElement.tick(nParticleTickData);

        vector.setX(-vector.getX());
        vector.setZ(-vector.getZ());

        nParticleTickData = particleTickData.withLocation(location.clone().add(vector));
        second.tick(nParticleTickData);
    }
}
